#include "claviernumerique.h"
#include "ui_claviernumerique.h"

//_________________________________________________________________________________
ClavierNumerique::ClavierNumerique(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::ClavierNumerique)
{
    ui->setupUi(this);
    destination = NULL;         // par de destination;
    // mise en forme des touches
    setLayout(ui->gridLayout);
    // création des boutons
    keysTitle<<"1"<<"2"<<"3"<<"del"
             <<"4"<<"5"<<"6"<<""
             <<"7"<<"8"<<"9"<<"clr"
             <<"0"<<"."<<"enter";
    for (int i=0 ; i<(int)keysTitle.size(); i++){ // les boutons numériques
                        QPushButton *b =new QPushButton(this);
                        b->setMinimumSize(QSize(50,50));
                        b->setMaximumSize(QSize(100,100));
                        b->setObjectName("button"+keysTitle[i]);
                        b->setText(keysTitle[i]);
                        // enter prend deux cases du gridLayout
                        if (i==14)ui->gridLayout->addWidget(b, i/4, i%4, 1,2);
                            else ui->gridLayout->addWidget(b, i/4, i%4);
                        buttons.push_back(b);
                        connect(b, SIGNAL(pressed()), this, SLOT(clickKey()));
                        }
}

//___________________________________________________________________________________
void ClavierNumerique::setObject(QLineEdit *lineEdit){
    if (lineEdit) this->destination = lineEdit;
}

//___________________________________________________________________________________
// une touche a été clickée
void ClavierNumerique::clickKey(){
    // y a t'il un lineedit valide attaché à ce clavier
    if (!destination) return;
    int i;
    QString br;             // une chaîne
    // quelle touche ?
    for (i=0 ; i<(int)buttons.size() && !buttons[i]->isDown() ; i++);
    // c'est la ième
    if (buttons[i]->text()=="clr") this->destination->setText("");
            else if (buttons[i]->text()=="del")destination->setText((br = destination->text()).remove(br.size()-1,1));
                else if (buttons[i]->text()=="enter") hide();
                    else  this->destination->setText(destination->text()+keysTitle[i]);
}

//___________________________________________________________________________________
ClavierNumerique::~ClavierNumerique()
{
    delete ui;
}
